<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 David Frerich (dfrerich@cdfre.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

namespace IMIA\ImiaBaseExt\Xclass\Install\Service;

/**
 * @package     imia_base
 * @subpackage  Xclass
 * @author      David Frerich <d.frerich@imia.de>
 */
class SqlExpectedSchemaService extends \TYPO3\CMS\Install\Service\SqlExpectedSchemaService
{
	/**
	 * Cycle through all loaded extensions and get full table definitions as concatenated string
	 *
	 * @param boolean $withStatic TRUE if sql from ext_tables_static+adt.sql should be loaded, too.
	 * @return string Concatenated SQL of loaded extensions ext_tables.sql
	 */
	public function getTablesDefinitionString($withStatic = FALSE)
    {
        $sqlString = array(parent::getTablesDefinitionString($withStatic));

		$loadedExtensionInformation = $GLOBALS['TYPO3_LOADED_EXT'];
		foreach ($loadedExtensionInformation as $extKey => $extensionConfiguration) {
            $file = \IMIA\ImiaBaseExt\Utility\DynamicConfiguration::getSql($extKey);
            if ($file && $file->exists()) {
                $sqlString[]= LF . $file->getContents();
            }
		}

		return implode(LF . LF . LF . LF, $sqlString);
	}
}
