<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if (!defined ('TYPO3_MODE')) {
    die ('Access denied.');
}

\IMIA\ImiaComposer\Utility\Composer::fetch();
\IMIA\ImiaBaseExt\Utility\DynamicConfiguration::build('localconf');

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['GLOBAL']['extTablesInclusion-PostProcessing'][$_EXTKEY] =
    'IMIA\ImiaBaseExt\Hook\TableConfigurationPostProcessing';

$GLOBALS['TYPO3_CONF_VARS']['SYS']['lang']['cache']['clear_menu'] = true;

/* Hooks */
$GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['extbase']['typeConverters'][] =
    'IMIA\ImiaBaseExt\Property\TypeConverter\ArrayConverter';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_tcemain.php']['clearCachePostProc']['tx_imiabaseext'] =
    'IMIA\ImiaBaseExt\Hook\DataHandler->clearCachePostProc';

require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY, 'Classes/Hook/DataHandler.php'));

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['additionalBackendItems']['cacheActions']['tx_imiabaseext'] =
    'IMIA\ImiaBaseExt\Hook\ClearCacheActions';

if ((float)TYPO3_version < 6.2) {
    // old install tool
    $GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install/mod/class.tx_install.php']['checkTheDatabase']['tx_imiabaseext'] =
        'IMIA\ImiaBaseExt\Hook\CheckTheDatabase';
}

/* Xclasses */
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Property\TypeConverter\PersistentObjectConverter'] = array(
    'className' => 'IMIA\ImiaBaseExt\Property\TypeConverter\PersistentObjectConverter',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Property\PropertyMapper'] = array(
    'className' => 'IMIA\ImiaBaseExt\Property\PropertyMapper',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Configuration\TypoScript\ConditionMatching\ConditionMatcher'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Configuration\TypoScript\ConditionMatching\ConditionMatcher',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Form\ElementConditionMatcher'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Form\ElementConditionMatcher',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Form\FormEngine'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Form\FormEngine',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\Form\Element\InlineElement'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Backend\Form\Element\InlineElement',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Backend'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Backend',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\Controller\ConfigurationController'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\Controller\ConfigurationController',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\Utility\ConfigurationUtility'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\Utility\ConfigurationUtility',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\Domain\Repository\ConfigurationItemRepository'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\Domain\Repository\ConfigurationItemRepository',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extensionmanager\ViewHelpers\Form\TypoScriptConstantsViewHelper'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extensionmanager\ViewHelpers\Form\TypoScriptConstantsViewHelper',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\Localization\Parser\LocallangXmlParser'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Core\Localization\Parser\LocallangXmlParser',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\Localization\Parser\XliffParser'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Core\Localization\Parser\XliffParser',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\Resource\ResourceStorage'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Core\Resource\ResourceStorage',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Frontend\Imaging\GifBuilder'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Frontend\Imaging\GifBuilder',
);

if ((float)TYPO3_version >= 6.2) {
    // new install tool
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Install\Service\SqlExpectedSchemaService'] = array(
        'className' => 'IMIA\ImiaBaseExt\Xclass\Install\Service\SqlExpectedSchemaService',
    );

    // extbase query parsing (onlyFields)
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Typo3QuerySettings'] = array(
        'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Typo3QuerySettings',
    );
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Storage\Typo3DbQueryParser'] = array(
        'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Storage\Typo3DbQueryParser',
    );
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Storage\Typo3DbBackend'] = array(
        'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Storage\Typo3DbBackend',
    );
}

$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Mapper\DataMapper'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Mapper\DataMapper',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Persistence\Generic\Session'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Persistence\Generic\Session',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Extbase\Configuration\BackendConfigurationManager'] = array(
    'className' => 'IMIA\ImiaBaseExt\Xclass\Extbase\Configuration\BackendConfigurationManager',
);


if (!\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded('imia_base')) {
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\Page\PageRenderer'] = array(
        'className' => 'IMIA\ImiaBaseExt\Xclass\Core\Page\PageRenderer',
    );
}

require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY, 'Configuration/DevMode.php'));

if (!class_exists('Psr\Log\LoggerInterface') && !\TYPO3\CMS\Core\Utility\GeneralUtility::_GP('install')) {
    try {
        new \TYPO3\CMS\Core\Log\Logger(null);
    } catch (\Exception $e){
        if (!function_exists('rrmdir')) {
            function rrmdir($dir) {
                if (!file_exists($dir)) {
                    return true;
                }
                if (!is_dir($dir)) {
                    return unlink($dir);
                }

                foreach (scandir($dir) as $item) {
                    if ($item != '.' && $item != '..') {
                        if (!rrmdir($dir . DIRECTORY_SEPARATOR . $item)) {
                            return false;
                        }
                    }
                }

                return rmdir($dir);
            }
        }

        @rrmdir(PATH_site . 'typo3temp/Cache/Data/cache_classes');
    }
}